/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import java.util.Objects;

/**
 * UserReference
 */

public class UserReference extends BaseReference {
  @JsonProperty("avatar")
  private String avatar = null;

  @JsonProperty("avatar_thumbnail")
  private String avatarThumbnail = null;

  @JsonProperty("first_name")
  private String firstName = null;

  @JsonProperty("last_name")
  private String lastName = null;

  @JsonProperty("page")
  private String page = null;

  @JsonProperty("slug")
  private String slug = null;

  @JsonProperty("uri")
  private String uri = null;

  public UserReference avatar(String avatar) {
    this.avatar = avatar;
    return this;
  }

   /**
   * The user avatar URL
   * @return avatar
  **/
  @ApiModelProperty(value = "The user avatar URL")
  public String getAvatar() {
    return avatar;
  }

  public void setAvatar(String avatar) {
    this.avatar = avatar;
  }

  public UserReference avatarThumbnail(String avatarThumbnail) {
    this.avatarThumbnail = avatarThumbnail;
    return this;
  }

   /**
   * The user avatar thumbnail URL. This is the square (500x500) and cropped version.
   * @return avatarThumbnail
  **/
  @ApiModelProperty(value = "The user avatar thumbnail URL. This is the square (500x500) and cropped version.")
  public String getAvatarThumbnail() {
    return avatarThumbnail;
  }

  public void setAvatarThumbnail(String avatarThumbnail) {
    this.avatarThumbnail = avatarThumbnail;
  }

   /**
   * The user first name
   * @return firstName
  **/
  @ApiModelProperty(value = "The user first name")
  public String getFirstName() {
    return firstName;
  }

   /**
   * The user larst name
   * @return lastName
  **/
  @ApiModelProperty(value = "The user larst name")
  public String getLastName() {
    return lastName;
  }

   /**
   * The user profile page URL
   * @return page
  **/
  @ApiModelProperty(value = "The user profile page URL")
  public String getPage() {
    return page;
  }

  public UserReference slug(String slug) {
    this.slug = slug;
    return this;
  }

   /**
   * The user permalink string
   * @return slug
  **/
  @ApiModelProperty(required = true, value = "The user permalink string")
  public String getSlug() {
    return slug;
  }

  public void setSlug(String slug) {
    this.slug = slug;
  }

  public UserReference uri(String uri) {
    this.uri = uri;
    return this;
  }

   /**
   * The user API URI
   * @return uri
  **/
  @ApiModelProperty(required = true, value = "The user API URI")
  public String getUri() {
    return uri;
  }

  public void setUri(String uri) {
    this.uri = uri;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UserReference userReference = (UserReference) o;
    return Objects.equals(this.avatar, userReference.avatar) &&
        Objects.equals(this.avatarThumbnail, userReference.avatarThumbnail) &&
        Objects.equals(this.firstName, userReference.firstName) &&
        Objects.equals(this.lastName, userReference.lastName) &&
        Objects.equals(this.page, userReference.page) &&
        Objects.equals(this.slug, userReference.slug) &&
        Objects.equals(this.uri, userReference.uri) &&
        super.equals(o);
  }

  @Override
  public int hashCode() {
    return Objects.hash(avatar, avatarThumbnail, firstName, lastName, page, slug, uri, super.hashCode());
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UserReference {\n");
    sb.append("    ").append(toIndentedString(super.toString())).append("\n");
    sb.append("    avatar: ").append(toIndentedString(avatar)).append("\n");
    sb.append("    avatarThumbnail: ").append(toIndentedString(avatarThumbnail)).append("\n");
    sb.append("    firstName: ").append(toIndentedString(firstName)).append("\n");
    sb.append("    lastName: ").append(toIndentedString(lastName)).append("\n");
    sb.append("    page: ").append(toIndentedString(page)).append("\n");
    sb.append("    slug: ").append(toIndentedString(slug)).append("\n");
    sb.append("    uri: ").append(toIndentedString(uri)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

